Module ij
Package ij.gui

# Class ImageWindow

java.lang.Object
java.awt.Component
java.awt.Container
java.awt.Window
java.awt.Frame
ij.gui.ImageWindow

All Implemented Interfaces:
  `FocusListener`, `MouseWheelListener`, `WindowListener`, `WindowStateListener`, `ImageObserver`, `MenuContainer`, `Serializable`, `EventListener`, `Accessible`

Direct Known Subclasses:
  `HistogramWindow`, `PlotWindow`, `StackWindow`

public class ImageWindow extends Frame implements FocusListener, WindowListener, WindowStateListener, MouseWheelListener
A frame for displaying images.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class java.awt.Frame

`Frame.AccessibleAWTFrame`

## Nested classes/interfaces inherited from class java.awt.Window

`Window.AccessibleAWTWindow, Window.Type`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`closed`
`static final int`
`HGAP`
`protected ImageCanvas`
`ic`
`protected ImageJ`
`ij`
`protected ImagePlus`
`imp`
`static final String`
`LOC_KEY`
`static final int`
`MIN_HEIGHT`
`static final int`
`MIN_WIDTH`
`boolean`
`running`
This variable is set false if the user presses the escape key or closes the window.
`boolean`
`running2`
This variable is set false if the user clicks in this window, presses the escape key, or closes the window.
`static long`
`setMenuBarTime`
`static final int`
`VGAP`

### Fields inherited from class java.awt.Frame

`CROSSHAIR_CURSOR, DEFAULT_CURSOR, E_RESIZE_CURSOR, HAND_CURSOR, ICONIFIED, MAXIMIZED_BOTH, MAXIMIZED_HORIZ, MAXIMIZED_VERT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NORMAL, NW_RESIZE_CURSOR, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, W_RESIZE_CURSOR, WAIT_CURSOR`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`ImageWindow(ImagePlus imp)`
`ImageWindow(ImagePlus imp, ImageCanvas ic)`
`ImageWindow(String title)`

## Method Summary

Modifier and Type
Method
Description
`Component`
`add(Component comp)`
`static void`
`centerNextImage()`
Causes the next image to be opened to be centered on the screen and displayed without informational text above the image.
`boolean`
`close()`
Removes this window from the window list and disposes of it.
`void`
`copy(boolean cut)`
Copies the current ROI to the clipboard.
`String`
`createSubtitle()`
Creates the subtitle.
`void`
`drawInfo(Graphics g)`
Draws the subtitle.
`void`
`focusGained(FocusEvent e)`
`void`
`focusLost(FocusEvent e)`
`ImageCanvas`
`getCanvas()`
`ImagePlus`
`getImagePlus()`
`static String`
`getImageSize(ImagePlus imp)`
`double`
`getInitialMagnification()`
`Insets`
`getInsets()`
`Insets`
`getInsets(boolean includeSmallImageMargins)`
Override Container getInsets() to make room for some text above the image.
`Rectangle`
`getMaximumBounds()`
`int`
`getSliderHeight()`
`boolean`
`isClosed()`
Has this window been closed?
`void`
`maximize()`
`void`
`minimize()`
`void`
`mouseMoved(int x, int y)`
This method is called by ImageCanvas.mouseMoved(MouseEvent).
`void`
`mouseWheelMoved(MouseWheelEvent e)`
`void`
`paint(Graphics g)`
`void`
`paste()`
`void`
`setImage(ImagePlus imp2)`
`static void`
`setImageJMenuBar(ImageWindow win)`
`void`
`setLocation(int x, int y)`
`void`
`setLocationAndSize(int x, int y, int width, int height)`
Moves and resizes this window.
`static void`
`setNextLocation(int x, int y)`
Causes the next image to be displayed at the specified location.
`static void`
`setNextLocation(Point loc)`
Causes the next image to be displayed at the specified location.
`void`
`setSliderHeight(int height)`
`String`
`toString()`
`void`
`updateImage(ImagePlus imp)`
`void`
`windowActivated(WindowEvent e)`
`void`
`windowClosed(WindowEvent e)`
`void`
`windowClosing(WindowEvent e)`
`void`
`windowDeactivated(WindowEvent e)`
`void`
`windowDeiconified(WindowEvent e)`
`void`
`windowIconified(WindowEvent e)`
`void`
`windowOpened(WindowEvent e)`
`void`
`windowStateChanged(WindowEvent e)`

### Methods inherited from class java.awt.Frame

`addNotify, getAccessibleContext, getCursorType, getExtendedState, getFrames, getIconImage, getMaximizedBounds, getMenuBar, getState, getTitle, isResizable, isUndecorated, paramString, remove, removeNotify, setBackground, setCursor, setExtendedState, setIconImage, setMaximizedBounds, setMenuBar, setOpacity, setResizable, setShape, setState, setTitle, setUndecorated`

### Methods inherited from class java.awt.Window

`addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, hide, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, postEvent, processEvent, processWindowEvent, processWindowFocusEvent, processWindowStateEvent, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImages, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, setVisible, show, toBack, toFront`

### Methods inherited from class java.awt.Container

`add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, update, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setMixingCutoutShape, setName, setPreferredSize, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.awt.MenuContainer

`getFont, postEvent`

## Field Details

### MIN_WIDTH

public static final int MIN_WIDTH

See Also:
  - Constant Field Values

### MIN_HEIGHT

public static final int MIN_HEIGHT

See Also:
  - Constant Field Values

### HGAP

public static final int HGAP

See Also:
  - Constant Field Values

### VGAP

public static final int VGAP

See Also:
  - Constant Field Values

### LOC_KEY

public static final String LOC_KEY

See Also:
  - Constant Field Values

### imp

protected ImagePlus imp

### ij

protected ImageJ ij

### ic

protected ImageCanvas ic

### closed

protected boolean closed

### setMenuBarTime

public static long setMenuBarTime

### running

public boolean running
This variable is set false if the user presses the escape key or closes the window.

### running2

public boolean running2
This variable is set false if the user clicks in this window, presses the escape key, or closes the window.

## Constructor Details

### ImageWindow

public ImageWindow(String title)

### ImageWindow

public ImageWindow(ImagePlus imp)

### ImageWindow

public ImageWindow(ImagePlus imp, ImageCanvas ic)

## Method Details

### getInitialMagnification

public double getInitialMagnification()

### getInsets

public Insets getInsets()

Overrides:
  `getInsets` in class `Container`

### getInsets

public Insets getInsets(boolean includeSmallImageMargins)
Override Container getInsets() to make room for some text above the image. With "includeSmallImageMargins", also includes the margins for padding an image that is too small for the window size.

### drawInfo

public void drawInfo(Graphics g)
Draws the subtitle.

### createSubtitle

public String createSubtitle()
Creates the subtitle.

### getImageSize

public static String getImageSize(ImagePlus imp)

### paint

public void paint(Graphics g)

Overrides:
  `paint` in class `Window`

### close

public boolean close()
Removes this window from the window list and disposes of it. Returns false if the user cancels the "save changes" dialog.

### getImagePlus

public ImagePlus getImagePlus()

### setImage

public void setImage(ImagePlus imp2)

### updateImage

public void updateImage(ImagePlus imp)

### getCanvas

public ImageCanvas getCanvas()

### getMaximumBounds

public Rectangle getMaximumBounds()

### add

public Component add(Component comp)

Overrides:
  `add` in class `Container`

### maximize

public void maximize()

### minimize

public void minimize()

### isClosed

public boolean isClosed()
Has this window been closed?

### focusGained

public void focusGained(FocusEvent e)

Specified by:
  `focusGained` in interface `FocusListener`

### windowActivated

public void windowActivated(WindowEvent e)

Specified by:
  `windowActivated` in interface `WindowListener`

### windowClosing

public void windowClosing(WindowEvent e)

Specified by:
  `windowClosing` in interface `WindowListener`

### windowStateChanged

public void windowStateChanged(WindowEvent e)

Specified by:
  `windowStateChanged` in interface `WindowStateListener`

### windowClosed

public void windowClosed(WindowEvent e)

Specified by:
  `windowClosed` in interface `WindowListener`

### windowDeactivated

public void windowDeactivated(WindowEvent e)

Specified by:
  `windowDeactivated` in interface `WindowListener`

### focusLost

public void focusLost(FocusEvent e)

Specified by:
  `focusLost` in interface `FocusListener`

### windowDeiconified

public void windowDeiconified(WindowEvent e)

Specified by:
  `windowDeiconified` in interface `WindowListener`

### windowIconified

public void windowIconified(WindowEvent e)

Specified by:
  `windowIconified` in interface `WindowListener`

### windowOpened

public void windowOpened(WindowEvent e)

Specified by:
  `windowOpened` in interface `WindowListener`

### mouseWheelMoved

public void mouseWheelMoved(MouseWheelEvent e)

Specified by:
  `mouseWheelMoved` in interface `MouseWheelListener`

### copy

public void copy(boolean cut)
Copies the current ROI to the clipboard. The entire image is copied if there is no ROI.

### paste

public void paste()

### mouseMoved

public void mouseMoved(int x, int y)
This method is called by ImageCanvas.mouseMoved(MouseEvent).

See Also:
  - `ImageCanvas.mouseMoved(java.awt.event.MouseEvent)`

### toString

public String toString()

Overrides:
  `toString` in class `Component`

### centerNextImage

public static void centerNextImage()
Causes the next image to be opened to be centered on the screen and displayed without informational text above the image.

### setNextLocation

public static void setNextLocation(Point loc)
Causes the next image to be displayed at the specified location.

### setNextLocation

public static void setNextLocation(int x, int y)
Causes the next image to be displayed at the specified location.

### setLocationAndSize

public void setLocationAndSize(int x, int y, int width, int height)
Moves and resizes this window. Changes the magnification so the image fills the window.

### setLocation

public void setLocation(int x, int y)

Overrides:
  `setLocation` in class `Window`

### setSliderHeight

public void setSliderHeight(int height)

### getSliderHeight

public int getSliderHeight()

### setImageJMenuBar

public static void setImageJMenuBar(ImageWindow win)